<template>
  <div class="wp-12 wp-layout wp-layout--no-pad wp-layout--form">
    <div class="wp-12 wp-layout wp-layout--no-pad">
      <wp-input class="wp-12" type="text" v-model="organization.name"
        label="Название организации" placeholder="NullTeam"/>
    </div>
    <div class="wp-12 wp-layout wp-layout--no-pad">
      <button class="wp-button wp-button--margin-right" @click="editOrganizationSettings">
        Сохранить изменения
      </button>
      <button class="wp-button wp-button--cancel" @click="$emit('close')">
        Отменить
      </button>
    </div>
  </div>
</template>

<script>
import { mapActions } from 'vuex';

import WpInput from '@/components/WpInput.vue';

export default {
  name: 'OrganizationSettings',
  components: {
    WpInput,
  },
  data() {
    return {
      organization: {
        name: '',
      },
    };
  },
  props: {
    data: {
      type: Object,
      default: () => undefined,
    },
  },
  methods: {
    ...mapActions('organization', ['updateOrganizationSettings']),
    async editOrganizationSettings() {
      try {
        await this.updateOrganizationSettings(this.organization);
        this.$toasted.success('Информация обновлена');
        this.$emit('close');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
  },
  mounted() {
    if (this.$props.data) {
      this.organization = Object.assign({}, this.$props.data);
    }
  },
};
</script>

<style></style>
